diff --git a/tests/intel-ci/fast-feedback.testlist b/tests/intel-ci/fast-feedback.testlist
index f71a16bc..34db4706 100644
--- a/tests/intel-ci/fast-feedback.testlist
+++ b/tests/intel-ci/fast-feedback.testlist
@@ -1,295 +1,296 @@
 # Keep alphabetically sorted by default
 
-igt@core_auth@basic-auth
-igt@core_prop_blob@basic
-igt@debugfs_test@read_all_entries
-igt@drv_getparams_basic@basic-eu-total
-igt@drv_getparams_basic@basic-subslice-total
-igt@drv_hangman@error-state-basic
-igt@gem_basic@bad-close
-igt@gem_basic@create-close
-igt@gem_basic@create-fd-close
-igt@gem_busy@basic-busy-default
-igt@gem_busy@basic-hang-default
-igt@gem_close_race@basic-process
-igt@gem_close_race@basic-threads
-igt@gem_cpu_reloc@basic
-igt@gem_cs_tlb@basic-default
-igt@gem_ctx_create@basic
-igt@gem_ctx_create@basic-files
-igt@gem_ctx_exec@basic
-igt@gem_ctx_param@basic
-igt@gem_ctx_param@basic-default
-igt@gem_ctx_switch@basic-default
-igt@gem_ctx_switch@basic-default-heavy
-igt@gem_exec_basic@basic-blt
-igt@gem_exec_basic@basic-bsd
-igt@gem_exec_basic@basic-bsd1
-igt@gem_exec_basic@basic-bsd2
-igt@gem_exec_basic@basic-default
-igt@gem_exec_basic@basic-render
-igt@gem_exec_basic@basic-vebox
-igt@gem_exec_basic@gtt-blt
-igt@gem_exec_basic@gtt-bsd
-igt@gem_exec_basic@gtt-bsd1
-igt@gem_exec_basic@gtt-bsd2
-igt@gem_exec_basic@gtt-default
-igt@gem_exec_basic@gtt-render
-igt@gem_exec_basic@gtt-vebox
-igt@gem_exec_basic@readonly-blt
-igt@gem_exec_basic@readonly-bsd
-igt@gem_exec_basic@readonly-bsd1
-igt@gem_exec_basic@readonly-bsd2
-igt@gem_exec_basic@readonly-default
-igt@gem_exec_basic@readonly-render
-igt@gem_exec_basic@readonly-vebox
-igt@gem_exec_create@basic
-igt@gem_exec_fence@basic-busy-default
-igt@gem_exec_fence@basic-wait-default
-igt@gem_exec_fence@basic-await-default
-igt@gem_exec_fence@await-hang-default
-igt@gem_exec_fence@nb-await-default
-igt@gem_exec_flush@basic-batch-kernel-default-cmd
-igt@gem_exec_flush@basic-batch-kernel-default-uc
-igt@gem_exec_flush@basic-batch-kernel-default-wb
-igt@gem_exec_flush@basic-uc-pro-default
-igt@gem_exec_flush@basic-uc-prw-default
-igt@gem_exec_flush@basic-uc-ro-default
-igt@gem_exec_flush@basic-uc-rw-default
-igt@gem_exec_flush@basic-uc-set-default
-igt@gem_exec_flush@basic-wb-pro-default
-igt@gem_exec_flush@basic-wb-prw-default
-igt@gem_exec_flush@basic-wb-ro-before-default
-igt@gem_exec_flush@basic-wb-ro-default
-igt@gem_exec_flush@basic-wb-rw-before-default
-igt@gem_exec_flush@basic-wb-rw-default
-igt@gem_exec_flush@basic-wb-set-default
-igt@gem_exec_gttfill@basic
-igt@gem_exec_nop@basic-parallel
-igt@gem_exec_nop@basic-series
-igt@gem_exec_parallel@basic
-igt@gem_exec_parse@basic-allowed
-igt@gem_exec_parse@basic-rejected
-igt@gem_exec_reloc@basic-cpu
-igt@gem_exec_reloc@basic-gtt
-igt@gem_exec_reloc@basic-cpu-gtt
-igt@gem_exec_reloc@basic-gtt-cpu
-igt@gem_exec_reloc@basic-cpu-read
-igt@gem_exec_reloc@basic-gtt-read
-igt@gem_exec_reloc@basic-write-cpu
-igt@gem_exec_reloc@basic-write-gtt
-igt@gem_exec_reloc@basic-write-read
-igt@gem_exec_reloc@basic-cpu-noreloc
-igt@gem_exec_reloc@basic-gtt-noreloc
-igt@gem_exec_reloc@basic-cpu-gtt-noreloc
-igt@gem_exec_reloc@basic-gtt-cpu-noreloc
-igt@gem_exec_reloc@basic-cpu-read-noreloc
-igt@gem_exec_reloc@basic-gtt-read-noreloc
-igt@gem_exec_reloc@basic-write-cpu-noreloc
-igt@gem_exec_reloc@basic-write-gtt-noreloc
-igt@gem_exec_reloc@basic-write-read-noreloc
-igt@gem_exec_reloc@basic-cpu-active
-igt@gem_exec_reloc@basic-gtt-active
-igt@gem_exec_reloc@basic-cpu-gtt-active
-igt@gem_exec_reloc@basic-gtt-cpu-active
-igt@gem_exec_reloc@basic-cpu-read-active
-igt@gem_exec_reloc@basic-gtt-read-active
-igt@gem_exec_reloc@basic-write-cpu-active
-igt@gem_exec_reloc@basic-write-gtt-active
-igt@gem_exec_reloc@basic-write-read-active
-igt@gem_exec_reloc@basic-softpin
-igt@gem_exec_store@basic-all
-igt@gem_exec_store@basic-blt
-igt@gem_exec_store@basic-bsd
-igt@gem_exec_store@basic-bsd1
-igt@gem_exec_store@basic-bsd2
-igt@gem_exec_store@basic-default
-igt@gem_exec_store@basic-render
-igt@gem_exec_store@basic-vebox
-igt@gem_exec_suspend@basic
-igt@gem_exec_suspend@basic-s3
-igt@gem_exec_suspend@basic-s4-devices
-igt@gem_flink_basic@bad-flink
-igt@gem_flink_basic@bad-open
-igt@gem_flink_basic@basic
-igt@gem_flink_basic@double-flink
-igt@gem_flink_basic@flink-lifetime
-igt@gem_linear_blits@basic
-igt@gem_mmap@basic
-igt@gem_mmap@basic-small-bo
-igt@gem_mmap_gtt@basic
-igt@gem_mmap_gtt@basic-copy
-igt@gem_mmap_gtt@basic-read
-igt@gem_mmap_gtt@basic-read-no-prefault
-igt@gem_mmap_gtt@basic-read-write
-igt@gem_mmap_gtt@basic-read-write-distinct
-igt@gem_mmap_gtt@basic-short
-igt@gem_mmap_gtt@basic-small-bo
-igt@gem_mmap_gtt@basic-small-bo-tiledx
-igt@gem_mmap_gtt@basic-small-bo-tiledy
-igt@gem_mmap_gtt@basic-small-copy
-igt@gem_mmap_gtt@basic-small-copy-xy
-igt@gem_mmap_gtt@basic-wc
-igt@gem_mmap_gtt@basic-write
-igt@gem_mmap_gtt@basic-write-cpu-read-gtt
-igt@gem_mmap_gtt@basic-write-gtt
-igt@gem_mmap_gtt@basic-write-gtt-no-prefault
-igt@gem_mmap_gtt@basic-write-no-prefault
-igt@gem_mmap_gtt@basic-write-read
-igt@gem_mmap_gtt@basic-write-read-distinct
-igt@gem_pread@basic
-igt@gem_pwrite@basic
-igt@gem_render_linear_blits@basic
-igt@gem_render_tiled_blits@basic
-igt@gem_ringfill@basic-default
-igt@gem_ringfill@basic-default-interruptible
-igt@gem_ringfill@basic-default-forked
-igt@gem_ringfill@basic-default-fd
-igt@gem_ringfill@basic-default-hang
-igt@gem_sync@basic-all
-igt@gem_sync@basic-each
-igt@gem_sync@basic-many-each
-igt@gem_sync@basic-store-all
-igt@gem_sync@basic-store-each
-igt@gem_tiled_blits@basic
-igt@gem_tiled_fence_blits@basic
-igt@gem_tiled_pread_basic
-igt@gem_wait@basic-busy-all
-igt@gem_wait@basic-wait-all
-igt@gem_wait@basic-await-all
-igt@gem_workarounds@basic-read
-igt@kms_addfb_basic@addfb25-bad-modifier
-igt@kms_addfb_basic@addfb25-framebuffer-vs-set-tiling
-igt@kms_addfb_basic@addfb25-modifier-no-flag
-igt@kms_addfb_basic@addfb25-x-tiled
-igt@kms_addfb_basic@addfb25-x-tiled-mismatch
-igt@kms_addfb_basic@addfb25-yf-tiled
-igt@kms_addfb_basic@addfb25-y-tiled
-igt@kms_addfb_basic@addfb25-y-tiled-small
-igt@kms_addfb_basic@bad-pitch-0
-igt@kms_addfb_basic@bad-pitch-1024
-igt@kms_addfb_basic@bad-pitch-128
-igt@kms_addfb_basic@bad-pitch-256
-igt@kms_addfb_basic@bad-pitch-32
-igt@kms_addfb_basic@bad-pitch-63
-igt@kms_addfb_basic@bad-pitch-65536
-igt@kms_addfb_basic@bad-pitch-999
-igt@kms_addfb_basic@basic
-igt@kms_addfb_basic@basic-x-tiled
-igt@kms_addfb_basic@basic-y-tiled
-igt@kms_addfb_basic@bo-too-small
-igt@kms_addfb_basic@bo-too-small-due-to-tiling
-igt@kms_addfb_basic@clobberred-modifier
-igt@kms_addfb_basic@framebuffer-vs-set-tiling
-igt@kms_addfb_basic@invalid-get-prop
-igt@kms_addfb_basic@invalid-get-prop-any
-igt@kms_addfb_basic@invalid-set-prop
-igt@kms_addfb_basic@invalid-set-prop-any
-igt@kms_addfb_basic@no-handle
-igt@kms_addfb_basic@size-max
-igt@kms_addfb_basic@small-bo
-igt@kms_addfb_basic@tile-pitch-mismatch
-igt@kms_addfb_basic@too-high
-igt@kms_addfb_basic@too-wide
-igt@kms_addfb_basic@unused-handle
-igt@kms_addfb_basic@unused-modifier
-igt@kms_addfb_basic@unused-offsets
-igt@kms_addfb_basic@unused-pitches
-igt@kms_busy@basic-flip-a
-igt@kms_busy@basic-flip-b
-igt@kms_busy@basic-flip-c
-igt@kms_chamelium@dp-hpd-fast
-igt@kms_chamelium@dp-edid-read
-igt@kms_chamelium@dp-crc-fast
-igt@kms_chamelium@hdmi-hpd-fast
-igt@kms_chamelium@hdmi-edid-read
-igt@kms_chamelium@hdmi-crc-fast
-igt@kms_chamelium@vga-hpd-fast
-igt@kms_chamelium@vga-edid-read
-igt@kms_chamelium@common-hpd-after-suspend
-igt@kms_cursor_legacy@basic-busy-flip-before-cursor-atomic
-igt@kms_cursor_legacy@basic-busy-flip-before-cursor-legacy
-igt@kms_cursor_legacy@basic-flip-after-cursor-atomic
-igt@kms_cursor_legacy@basic-flip-after-cursor-legacy
-igt@kms_cursor_legacy@basic-flip-after-cursor-varying-size
-igt@kms_cursor_legacy@basic-flip-before-cursor-atomic
-igt@kms_cursor_legacy@basic-flip-before-cursor-legacy
-igt@kms_cursor_legacy@basic-flip-before-cursor-varying-size
-igt@kms_flip@basic-flip-vs-dpms
-igt@kms_flip@basic-flip-vs-modeset
-igt@kms_flip@basic-flip-vs-wf_vblank
-igt@kms_flip@basic-plain-flip
-igt@kms_force_connector_basic@force-connector-state
-igt@kms_force_connector_basic@force-edid
-igt@kms_force_connector_basic@force-load-detect
-igt@kms_force_connector_basic@prune-stale-modes
-igt@kms_frontbuffer_tracking@basic
-igt@kms_pipe_crc_basic@bad-nb-words-1
-igt@kms_pipe_crc_basic@bad-nb-words-3
-igt@kms_pipe_crc_basic@bad-pipe
-igt@kms_pipe_crc_basic@bad-source
-igt@kms_pipe_crc_basic@hang-read-crc-pipe-a
-igt@kms_pipe_crc_basic@hang-read-crc-pipe-b
-igt@kms_pipe_crc_basic@hang-read-crc-pipe-c
-igt@kms_pipe_crc_basic@nonblocking-crc-pipe-a
-igt@kms_pipe_crc_basic@nonblocking-crc-pipe-a-frame-sequence
-igt@kms_pipe_crc_basic@nonblocking-crc-pipe-b
-igt@kms_pipe_crc_basic@nonblocking-crc-pipe-b-frame-sequence
-igt@kms_pipe_crc_basic@nonblocking-crc-pipe-c
-igt@kms_pipe_crc_basic@nonblocking-crc-pipe-c-frame-sequence
-igt@kms_pipe_crc_basic@read-crc-pipe-a
-igt@kms_pipe_crc_basic@read-crc-pipe-a-frame-sequence
-igt@kms_pipe_crc_basic@read-crc-pipe-b
-igt@kms_pipe_crc_basic@read-crc-pipe-b-frame-sequence
-igt@kms_pipe_crc_basic@read-crc-pipe-c
-igt@kms_pipe_crc_basic@read-crc-pipe-c-frame-sequence
-igt@kms_pipe_crc_basic@suspend-read-crc-pipe-a
-igt@kms_pipe_crc_basic@suspend-read-crc-pipe-b
-igt@kms_pipe_crc_basic@suspend-read-crc-pipe-c
+# igt@core_auth@basic-auth
+# igt@core_prop_blob@basic
+# igt@debugfs_test@read_all_entries
+# igt@drv_getparams_basic@basic-eu-total
+# igt@drv_getparams_basic@basic-subslice-total
+# igt@drv_hangman@error-state-basic
+# igt@gem_basic@bad-close
+# igt@gem_basic@create-close
+# igt@gem_basic@create-fd-close
+# igt@gem_busy@basic-busy-default
+# igt@gem_busy@basic-hang-default
+# igt@gem_close_race@basic-process
+# igt@gem_close_race@basic-threads
+# igt@gem_cpu_reloc@basic
+# igt@gem_cs_tlb@basic-default
+# igt@gem_ctx_create@basic
+# igt@gem_ctx_create@basic-files
+# igt@gem_ctx_exec@basic
+# igt@gem_ctx_param@basic
+# igt@gem_ctx_param@basic-default
+# igt@gem_ctx_switch@basic-default
+# igt@gem_ctx_switch@basic-default-heavy
+# igt@gem_exec_basic@basic-blt
+# igt@gem_exec_basic@basic-bsd
+# igt@gem_exec_basic@basic-bsd1
+# igt@gem_exec_basic@basic-bsd2
+# igt@gem_exec_basic@basic-default
+# igt@gem_exec_basic@basic-render
+# igt@gem_exec_basic@basic-vebox
+# igt@gem_exec_basic@gtt-blt
+# igt@gem_exec_basic@gtt-bsd
+# igt@gem_exec_basic@gtt-bsd1
+# igt@gem_exec_basic@gtt-bsd2
+# igt@gem_exec_basic@gtt-default
+# igt@gem_exec_basic@gtt-render
+# igt@gem_exec_basic@gtt-vebox
+# igt@gem_exec_basic@readonly-blt
+# igt@gem_exec_basic@readonly-bsd
+# igt@gem_exec_basic@readonly-bsd1
+# igt@gem_exec_basic@readonly-bsd2
+# igt@gem_exec_basic@readonly-default
+# igt@gem_exec_basic@readonly-render
+# igt@gem_exec_basic@readonly-vebox
+# igt@gem_exec_create@basic
+# igt@gem_exec_fence@basic-busy-default
+# igt@gem_exec_fence@basic-wait-default
+# igt@gem_exec_fence@basic-await-default
+# igt@gem_exec_fence@await-hang-default
+# igt@gem_exec_fence@nb-await-default
+# igt@gem_exec_flush@basic-batch-kernel-default-cmd
+# igt@gem_exec_flush@basic-batch-kernel-default-uc
+# igt@gem_exec_flush@basic-batch-kernel-default-wb
+# igt@gem_exec_flush@basic-uc-pro-default
+# igt@gem_exec_flush@basic-uc-prw-default
+# igt@gem_exec_flush@basic-uc-ro-default
+# igt@gem_exec_flush@basic-uc-rw-default
+# igt@gem_exec_flush@basic-uc-set-default
+# igt@gem_exec_flush@basic-wb-pro-default
+# igt@gem_exec_flush@basic-wb-prw-default
+# igt@gem_exec_flush@basic-wb-ro-before-default
+# igt@gem_exec_flush@basic-wb-ro-default
+# igt@gem_exec_flush@basic-wb-rw-before-default
+# igt@gem_exec_flush@basic-wb-rw-default
+# igt@gem_exec_flush@basic-wb-set-default
+# igt@gem_exec_gttfill@basic
+# igt@gem_exec_nop@basic-parallel
+# igt@gem_exec_nop@basic-series
+# igt@gem_exec_parallel@basic
+# igt@gem_exec_parse@basic-allowed
+# igt@gem_exec_parse@basic-rejected
+# igt@gem_exec_reloc@basic-cpu
+# igt@gem_exec_reloc@basic-gtt
+# igt@gem_exec_reloc@basic-cpu-gtt
+# igt@gem_exec_reloc@basic-gtt-cpu
+# igt@gem_exec_reloc@basic-cpu-read
+# igt@gem_exec_reloc@basic-gtt-read
+# igt@gem_exec_reloc@basic-write-cpu
+# igt@gem_exec_reloc@basic-write-gtt
+# igt@gem_exec_reloc@basic-write-read
+# igt@gem_exec_reloc@basic-cpu-noreloc
+# igt@gem_exec_reloc@basic-gtt-noreloc
+# igt@gem_exec_reloc@basic-cpu-gtt-noreloc
+# igt@gem_exec_reloc@basic-gtt-cpu-noreloc
+# igt@gem_exec_reloc@basic-cpu-read-noreloc
+# igt@gem_exec_reloc@basic-gtt-read-noreloc
+# igt@gem_exec_reloc@basic-write-cpu-noreloc
+# igt@gem_exec_reloc@basic-write-gtt-noreloc
+# igt@gem_exec_reloc@basic-write-read-noreloc
+# igt@gem_exec_reloc@basic-cpu-active
+# igt@gem_exec_reloc@basic-gtt-active
+# igt@gem_exec_reloc@basic-cpu-gtt-active
+# igt@gem_exec_reloc@basic-gtt-cpu-active
+# igt@gem_exec_reloc@basic-cpu-read-active
+# igt@gem_exec_reloc@basic-gtt-read-active
+# igt@gem_exec_reloc@basic-write-cpu-active
+# igt@gem_exec_reloc@basic-write-gtt-active
+# igt@gem_exec_reloc@basic-write-read-active
+# igt@gem_exec_reloc@basic-softpin
+# igt@gem_exec_store@basic-all
+# igt@gem_exec_store@basic-blt
+# igt@gem_exec_store@basic-bsd
+# igt@gem_exec_store@basic-bsd1
+# igt@gem_exec_store@basic-bsd2
+# igt@gem_exec_store@basic-default
+# igt@gem_exec_store@basic-render
+# igt@gem_exec_store@basic-vebox
+# igt@gem_exec_suspend@basic
+# igt@gem_exec_suspend@basic-s3
+# igt@gem_exec_suspend@basic-s4-devices
+# igt@gem_flink_basic@bad-flink
+# igt@gem_flink_basic@bad-open
+# igt@gem_flink_basic@basic
+# igt@gem_flink_basic@double-flink
+# igt@gem_flink_basic@flink-lifetime
+# igt@gem_linear_blits@basic
+# igt@gem_mmap@basic
+# igt@gem_mmap@basic-small-bo
+# igt@gem_mmap_gtt@basic
+# igt@gem_mmap_gtt@basic-copy
+# igt@gem_mmap_gtt@basic-read
+# igt@gem_mmap_gtt@basic-read-no-prefault
+# igt@gem_mmap_gtt@basic-read-write
+# igt@gem_mmap_gtt@basic-read-write-distinct
+# igt@gem_mmap_gtt@basic-short
+# igt@gem_mmap_gtt@basic-small-bo
+# igt@gem_mmap_gtt@basic-small-bo-tiledx
+# igt@gem_mmap_gtt@basic-small-bo-tiledy
+# igt@gem_mmap_gtt@basic-small-copy
+# igt@gem_mmap_gtt@basic-small-copy-xy
+# igt@gem_mmap_gtt@basic-wc
+# igt@gem_mmap_gtt@basic-write
+# igt@gem_mmap_gtt@basic-write-cpu-read-gtt
+# igt@gem_mmap_gtt@basic-write-gtt
+# igt@gem_mmap_gtt@basic-write-gtt-no-prefault
+# igt@gem_mmap_gtt@basic-write-no-prefault
+# igt@gem_mmap_gtt@basic-write-read
+# igt@gem_mmap_gtt@basic-write-read-distinct
+# igt@gem_pread@basic
+# igt@gem_pwrite@basic
+# igt@gem_render_linear_blits@basic
+# igt@gem_render_tiled_blits@basic
+# igt@gem_ringfill@basic-default
+# igt@gem_ringfill@basic-default-interruptible
+# igt@gem_ringfill@basic-default-forked
+# igt@gem_ringfill@basic-default-fd
+# igt@gem_ringfill@basic-default-hang
+# igt@gem_sync@basic-all
+# igt@gem_sync@basic-each
+# igt@gem_sync@basic-many-each
+# igt@gem_sync@basic-store-all
+# igt@gem_sync@basic-store-each
+# igt@gem_tiled_blits@basic
+# igt@gem_tiled_fence_blits@basic
+# igt@gem_tiled_pread_basic
+# igt@gem_wait@basic-busy-all
+# igt@gem_wait@basic-wait-all
+# igt@gem_wait@basic-await-all
+# igt@gem_workarounds@basic-read
+# igt@kms_addfb_basic@addfb25-bad-modifier
+# igt@kms_addfb_basic@addfb25-framebuffer-vs-set-tiling
+# igt@kms_addfb_basic@addfb25-modifier-no-flag
+# igt@kms_addfb_basic@addfb25-x-tiled
+# igt@kms_addfb_basic@addfb25-x-tiled-mismatch
+# igt@kms_addfb_basic@addfb25-yf-tiled
+# igt@kms_addfb_basic@addfb25-y-tiled
+# igt@kms_addfb_basic@addfb25-y-tiled-small
+# igt@kms_addfb_basic@bad-pitch-0
+# igt@kms_addfb_basic@bad-pitch-1024
+# igt@kms_addfb_basic@bad-pitch-128
+# igt@kms_addfb_basic@bad-pitch-256
+# igt@kms_addfb_basic@bad-pitch-32
+# igt@kms_addfb_basic@bad-pitch-63
+# igt@kms_addfb_basic@bad-pitch-65536
+# igt@kms_addfb_basic@bad-pitch-999
+# igt@kms_addfb_basic@basic
+# igt@kms_addfb_basic@basic-x-tiled
+# igt@kms_addfb_basic@basic-y-tiled
+# igt@kms_addfb_basic@bo-too-small
+# igt@kms_addfb_basic@bo-too-small-due-to-tiling
+# igt@kms_addfb_basic@clobberred-modifier
+# igt@kms_addfb_basic@framebuffer-vs-set-tiling
+# igt@kms_addfb_basic@invalid-get-prop
+# igt@kms_addfb_basic@invalid-get-prop-any
+# igt@kms_addfb_basic@invalid-set-prop
+# igt@kms_addfb_basic@invalid-set-prop-any
+# igt@kms_addfb_basic@no-handle
+# igt@kms_addfb_basic@size-max
+# igt@kms_addfb_basic@small-bo
+# igt@kms_addfb_basic@tile-pitch-mismatch
+# igt@kms_addfb_basic@too-high
+# igt@kms_addfb_basic@too-wide
+# igt@kms_addfb_basic@unused-handle
+# igt@kms_addfb_basic@unused-modifier
+# igt@kms_addfb_basic@unused-offsets
+# igt@kms_addfb_basic@unused-pitches
+# igt@kms_busy@basic-flip-a
+# igt@kms_busy@basic-flip-b
+# igt@kms_busy@basic-flip-c
+# igt@kms_chamelium@dp-hpd-fast
+# igt@kms_chamelium@dp-edid-read
+# igt@kms_chamelium@dp-crc-fast
+# igt@kms_chamelium@hdmi-hpd-fast
+# igt@kms_chamelium@hdmi-edid-read
+# igt@kms_chamelium@hdmi-crc-fast
+# igt@kms_chamelium@vga-hpd-fast
+# igt@kms_chamelium@vga-edid-read
+# igt@kms_chamelium@common-hpd-after-suspend
+# igt@kms_cursor_legacy@basic-busy-flip-before-cursor-atomic
+# igt@kms_cursor_legacy@basic-busy-flip-before-cursor-legacy
+# igt@kms_cursor_legacy@basic-flip-after-cursor-atomic
+# igt@kms_cursor_legacy@basic-flip-after-cursor-legacy
+# igt@kms_cursor_legacy@basic-flip-after-cursor-varying-size
+# igt@kms_cursor_legacy@basic-flip-before-cursor-atomic
+# igt@kms_cursor_legacy@basic-flip-before-cursor-legacy
+# igt@kms_cursor_legacy@basic-flip-before-cursor-varying-size
+# igt@kms_flip@basic-flip-vs-dpms
+# igt@kms_flip@basic-flip-vs-modeset
+# igt@kms_flip@basic-flip-vs-wf_vblank
+# igt@kms_flip@basic-plain-flip
+# igt@kms_force_connector_basic@force-connector-state
+# igt@kms_force_connector_basic@force-edid
+# igt@kms_force_connector_basic@force-load-detect
+# igt@kms_force_connector_basic@prune-stale-modes
+# igt@kms_frontbuffer_tracking@basic
+# igt@kms_pipe_crc_basic@bad-nb-words-1
+# igt@kms_pipe_crc_basic@bad-nb-words-3
+# igt@kms_pipe_crc_basic@bad-pipe
+# igt@kms_pipe_crc_basic@bad-source
+# igt@kms_pipe_crc_basic@hang-read-crc-pipe-a
+# igt@kms_pipe_crc_basic@hang-read-crc-pipe-b
+# igt@kms_pipe_crc_basic@hang-read-crc-pipe-c
+# igt@kms_pipe_crc_basic@nonblocking-crc-pipe-a
+# igt@kms_pipe_crc_basic@nonblocking-crc-pipe-a-frame-sequence
+# igt@kms_pipe_crc_basic@nonblocking-crc-pipe-b
+# igt@kms_pipe_crc_basic@nonblocking-crc-pipe-b-frame-sequence
+# igt@kms_pipe_crc_basic@nonblocking-crc-pipe-c
+# igt@kms_pipe_crc_basic@nonblocking-crc-pipe-c-frame-sequence
+# igt@kms_pipe_crc_basic@read-crc-pipe-a
+# igt@kms_pipe_crc_basic@read-crc-pipe-a-frame-sequence
+# igt@kms_pipe_crc_basic@read-crc-pipe-b
+# igt@kms_pipe_crc_basic@read-crc-pipe-b-frame-sequence
+# igt@kms_pipe_crc_basic@read-crc-pipe-c
+# igt@kms_pipe_crc_basic@read-crc-pipe-c-frame-sequence
+# igt@kms_pipe_crc_basic@suspend-read-crc-pipe-a
+# igt@kms_pipe_crc_basic@suspend-read-crc-pipe-b
+# igt@kms_pipe_crc_basic@suspend-read-crc-pipe-c
 igt@kms_psr_sink_crc@psr_basic
-igt@kms_setmode@basic-clone-single-crtc
-igt@kms_sink_crc_basic
-igt@pm_backlight@basic-brightness
-igt@pm_rpm@basic-pci-d3-state
-igt@pm_rpm@basic-rte
-igt@pm_rps@basic-api
-igt@prime_busy@basic-after-default
-igt@prime_busy@basic-before-default
-igt@prime_busy@basic-wait-after-default
-igt@prime_busy@basic-wait-before-default
-igt@prime_self_import@basic-llseek-bad
-igt@prime_self_import@basic-llseek-size
-igt@prime_self_import@basic-with_fd_dup
-igt@prime_self_import@basic-with_one_bo
-igt@prime_self_import@basic-with_one_bo_two_files
-igt@prime_self_import@basic-with_two_bos
-igt@prime_vgem@basic-busy-default
-igt@prime_vgem@basic-fence-flip
-igt@prime_vgem@basic-fence-mmap
-igt@prime_vgem@basic-fence-read
-igt@prime_vgem@basic-fence-wait-default
-igt@prime_vgem@basic-gtt
-igt@prime_vgem@basic-read
-igt@prime_vgem@basic-sync-default
-igt@prime_vgem@basic-wait-default
-igt@prime_vgem@basic-write
-igt@vgem_basic@setversion
-igt@vgem_basic@create
-igt@vgem_basic@debugfs
-igt@vgem_basic@dmabuf-export
-igt@vgem_basic@dmabuf-fence
-igt@vgem_basic@dmabuf-fence-before
-igt@vgem_basic@dmabuf-mmap
-igt@vgem_basic@mmap
-igt@vgem_basic@second-client
-igt@vgem_basic@sysfs
+igt@kms_psr_sink_crc@psr_drrs
+# igt@kms_setmode@basic-clone-single-crtc
+# igt@kms_sink_crc_basic
+# igt@pm_backlight@basic-brightness
+# igt@pm_rpm@basic-pci-d3-state
+# igt@pm_rpm@basic-rte
+# igt@pm_rps@basic-api
+# igt@prime_busy@basic-after-default
+# igt@prime_busy@basic-before-default
+# igt@prime_busy@basic-wait-after-default
+# igt@prime_busy@basic-wait-before-default
+# igt@prime_self_import@basic-llseek-bad
+# igt@prime_self_import@basic-llseek-size
+# igt@prime_self_import@basic-with_fd_dup
+# igt@prime_self_import@basic-with_one_bo
+# igt@prime_self_import@basic-with_one_bo_two_files
+# igt@prime_self_import@basic-with_two_bos
+# igt@prime_vgem@basic-busy-default
+# igt@prime_vgem@basic-fence-flip
+# igt@prime_vgem@basic-fence-mmap
+# igt@prime_vgem@basic-fence-read
+# igt@prime_vgem@basic-fence-wait-default
+# igt@prime_vgem@basic-gtt
+# igt@prime_vgem@basic-read
+# igt@prime_vgem@basic-sync-default
+# igt@prime_vgem@basic-wait-default
+# igt@prime_vgem@basic-write
+# igt@vgem_basic@setversion
+# igt@vgem_basic@create
+# igt@vgem_basic@debugfs
+# igt@vgem_basic@dmabuf-export
+# igt@vgem_basic@dmabuf-fence
+# igt@vgem_basic@dmabuf-fence-before
+# igt@vgem_basic@dmabuf-mmap
+# igt@vgem_basic@mmap
+# igt@vgem_basic@second-client
+# igt@vgem_basic@sysfs
 
 # All tests that do module unloading and reloading are executed last.
 # They will sometimes reveal issues of earlier tests leaving the
 # driver in a broken state that is not otherwise noticed in that test.
 
-igt@vgem_basic@unload
-igt@drv_module_reload@basic-reload
-igt@drv_module_reload@basic-no-display
-igt@drv_module_reload@basic-reload-inject
-igt@gvt_basic@invalid-placeholder-test
+# igt@vgem_basic@unload
+# igt@drv_module_reload@basic-reload
+# igt@drv_module_reload@basic-no-display
+# igt@drv_module_reload@basic-reload-inject
+# igt@gvt_basic@invalid-placeholder-test